#!/bin/bash

# Copyright 2013 SUSE Linux Products GmbH
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may
# not use this file except in compliance with the License. You may obtain
# a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations
# under the License.

if [ ${DIB_DEBUG_TRACE:-0} -gt 0 ]; then
    set -x
fi
set -eu
set -o pipefail

MAP_ELEMENT=
ACTION=install
ACTION_ARGS="--no-recommends"

SCRIPTNAME=$(basename $0)
function show_options () {
    echo "Usage: $SCRIPTNAME [package ...]"
    echo
    echo "Options:"
    echo "    -u          -- update all packages"
    echo "    -e          -- erase/remove packages"
    echo "    -d          -- download the packages only"
    echo "    -m          -- use custom element package map (Example: -m nova)"
    exit 0
}

function run_zypper() {
    # TODO: Uncertain if this can ever block wanting input from user
    zypper --non-interactive --gpg-auto-import-keys "$@"
}

TEMP=$(getopt -o hudem: -n $SCRIPTNAME -- "$@")
if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
eval set -- "$TEMP"

while true ; do
    case "$1" in
        -u) run_zypper dist-upgrade --no-recommends; exit 0;;
        -e) ACTION="remove"; ACTION_ARGS="--clean-deps"; shift;;
        -d) ACTION_ARGS="${ACTION_ARGS} --download-only"; shift;;
        -m) MAP_ELEMENT=$2; shift 2;;
        -h) show_options;;
        --) shift; break ;;
        *) echo "Error: unsupported option $1."; exit 1;;
    esac
done

PKGS=$@
if [ -n "$MAP_ELEMENT" ]; then
    if ! PKGS=$(pkg-map --element $MAP_ELEMENT $@); then
        echo "bin/pkg-map error. $PKGS"
        exit 1
    fi
fi

if [ -z "${PKGS}" ]; then
    echo "Not running install-packages $ACTION with empty packages list"
else
    run_zypper $ACTION $ACTION_ARGS $PKGS
fi
